/**********************************************************/
/*                                                        */
/*                  QAxisSynZoomSvc                  */
/*                       1.2.2                      */
/*                                                        */
/*        */
/*  ,             */
/* QChartSynZoom,    1.6.0.                 */
/*                                                        */
/*    ,                 */
/* . -  ., 2012 .,       */
/*   . . , . .        */
/*                                                        */
/*     . */
/*   .                         */
/*                                                        */
/**********************************************************/

#ifndef QAXISSYNZOOMSVC_H
#define QAXISSYNZOOMSVC_H

#include "qchartsynzoom.h"

class QAxisSynZoomSvc : public QObject
{
    Q_OBJECT

public:
    // 
    explicit QAxisSynZoomSvc();

    //     
    void attach(QChartSynZoom *);

    // /  
    void setLightMode(bool);
    //   ,   
    void setAxisRubberBandColor(QColor);
    // /   
    // ( ,    )
    void indicateAxisZoom(bool);

protected:
    //   
    bool eventFilter(QObject *,QEvent *);

private slots:
    //   -   
    void connectPlot(int);

private:
    QChartSynZoom *zoom;    //   
    bool light;             //   (  )
    QWidget *zwid;          //      
    QColor awClr;           //  ,   
    bool indiAxZ;           //    
    QCursor tCursor;        //     

    double scb_xl,scb_xr;   //      x    
    double scb_yb,scb_yt;   //      y    
    double scb_wx,scb_hy;   //         
    int scb_pxl,scb_pyt;    //          
                            // (   )
    int scb_pw,scb_ph;      //         
                            // ( )
    int scp_x,scp_y;        //      
                            // (        )
    int sab_pxl,sab_pyt;    //          
                            // (    )

    //   
    int limitSize(int,int);
    //     
    QRect *axisZoomRect(QPoint,int,int);
    //    
    void showZoomWidget(QPoint,int,int);
    //    
    double limitScale(double,double);
    //     
    void axisApplyMove(QPoint,int,int);

    //      
    void axisMouseEvent(QEvent *,int,int);

    //       
    // (   )
    void startAxisZoom(QMouseEvent *,int,int);
    //   
    // (   )
    void procAxisZoom(QMouseEvent *,int,int);
    //    
    // (   )
    void endAxisZoom(QMouseEvent *,int,int);
};

#endif // QAXISSYNZOOMSVC_H
